//========================================================================
//  The following example routines have been provided by the Technical
//  Support staff at Borland International.  They are provided as a
//  courtesy and not as part of a Borland product, and as such, are
//  provided without the assurance of technical support or any specific
//  guarantees.
//========================================================================
//
// myapp.h:  The class definition for TMyApp.
//

//
// class TMyApp
//      The application object, derived from the abstract class TApplication
//
// Member functions:
//      TMyApp - Constructor
//      initMenuBar - custom menu
//      initStatusLine - custom status line
//      handleEvent - now handling menu events
//      aboutDlg - creates and shows about box
//      window - creates a window and inserts into desktop
//

class TMyApp : public TApplication
{

public:

    TMyApp();
    static TMenuBar *initMenuBar( TRect r );
    static TStatusLine *initStatusLine( TRect r );
    virtual void handleEvent( TEvent& event);
    virtual void idle();

private:

    void aboutDlg();
    void window();
    void funkView();

    void restoreDeskTop();
    void loadDeskTop(fpstream& s);
    void storeDeskTop(fpstream& s);
    void saveDeskTop();

    THeapView *heap;
    TClockView *clock;

};
